package com.appbackend.aleph.utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.temporal.ChronoUnit;
import java.util.Date;

public class DateUtils {

     public static Date parseStringToDate(String format, String dateString) {
        if (dateString != null && !dateString.isEmpty()) {
            SimpleDateFormat dateFormat = new SimpleDateFormat(format);
            try {
                return dateFormat.parse(dateString);
            } catch (ParseException exception) {
                return null;
            }
        } else {
            return null;
        }
    }

    public static String parseDateToString(Date date) {
        if(date!=null) {
            SimpleDateFormat dateFormat = new SimpleDateFormat("dd.MM.yyyy");
            return dateFormat.format(date);
        } else {
            return null;
        }
    }

    public static long getDiffInSeconds(LocalDateTime time) {
        LocalDateTime now = LocalDateTime.now();
        return ChronoUnit.SECONDS.between(time, now);
    }
}
