import React from "react";
import {View} from "react-native";

class Button extends Component {
    constructor(props) {
        super(props);
        this.state = {pressing: false};
    }

    _onPressIn = () => {
        this.setState({pressing: true});
    };
    _onPressOut = () => {
        this.setState({pressing: false});
    };

    render() {
        return (
            <View style={styles.container}>
                <TouchableHighlight
                    onPressIn={this._onPressIn}
                    onPressOut={this._onPressOut}
                    style={styles.touchable}
                >
                    <View style={styles.button}>
                        <Text style={styles.welcome}>
                            {this.state.pressing ? "EEK!" : "PUSH ME"}
                        </Text>
                    </View>
                </TouchableHighlight>
            </View>
        );
    }
}


export default class App extends React.Component {
    render() {
        return (
            <FancyBorder>
                <Text>Text s rámečkem</Text>
            </FancyBorder>
        );
    }
}

function FancyBorder(props) {
    return (
        <View style={styles.fancyBorder}>
            {props.children}
        </View>
    );
}

const styles = StyleSheet.create({
    fancyBorder: {
        alignContent: 'center',
        justifyContent: 'center',
        padding: 8,
        borderColor: '#4287f5',
        borderWidth: 10,
    },
});


const styles = StyleSheet.create({
    fancyBorder: {
        alignContent: 'center',
        justifyContent: 'center',
        paddingTop: Constants.statusBarHeight,
        backgroundColor: '#ecf0f1',
        padding: 8,
        borderColor: '#4287f5',
        borderWidth: 10,
    },
});


export default class App extends React.Component {
    imageUri = 'https://image.shutterstock.com/image-vector/free-sample-rubber-stamp-vector-600w-217430497.jpg';

    render() {
        return (
            <FancyBorder>
                <Text>Text s rámečkem a obrázkem obalený komponentou FancyBorder</Text>
                <Image source={{uri: this.imageUri}}
                />
            </FancyBorder>
        );
    }
}


export default class App extends React.Component {
    render() {
        return (
            <View style={styles.container}>
                <Text style={styles.text}>StyleSheet object</Text>
            </View>
        );
    }
}

const styles = StyleSheet.create({
    container: {
        flex: 1,
        alignContent: 'center',
        justifyContent: 'center',
        backgroundColor: '#4287f5',
        textAlign: 'center',
        alignItems: 'center',
    },
    text: {
        color: 'yellow',
        fontWeight: 800
    }
});


export default class App extends React.Component {
    render() {
        return (
            <View style={{
                flex: 1,
                alignContent: 'center',
                justifyContent: 'center',
                backgroundColor: '#4287f5',
                textAlign: 'center',
                alignItems: 'center',
            }}>
                <Text style={{
                    color: 'yellow',
                    fontWeight: 800
                }}>StyleSheet object</Text>
            </View>
        );
    }
}


function Hello(props) {
    return (
        <Text>
            Hello:{props.name}
        </Text>
    );
}


class Example extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            count: 0
        };
    }
}

function Example() {
    const [count, setCount] = React.useState(0);

    return (
        <View>
            <Button onPress={() => setCount(count + 1)} title={`Clicked times:${count}`}/>
        </View>
    );
}


useEffect(() => {
    // volá se při zavedení komponenty do DOMu a jejím přerenderování
    return () => {
        // volá se při odebírání komponenty z DOMu
    };
});

React.useEffect(() => {
    // volá se při tvorbě komponenty a jejím překreslení, ale
    // pouze pokud se změní hodnota proměnné someValue
}, [someValue]);


const MyContext = React.createContext(null);

export default class App extends React.Component {
    contextValue = {
        sayHello: () => {
            alert('hello from context');
        },
        someValue: 'value from context',
    };

    render() {
        return (
            <MyContext.Provider value={this.contextValue}>
                <View>
                    <View>
                        <Text>Testing Context API</Text>
                        <Consumer/>
                    </View>
                </View>
            </MyContext.Provider>
        );
    }
}

class Consumer extends React.Component {
    static contextType = MyContext;

    render() {
        return (
            <View>
                <Button onPress={this.context.sayHello} title='press' />
                <Text>{this.context.someValue}</Text>
            </View>
        );
    }
}


function Consumer() {
    const context = React.useContext(MyContext);

    return (
        <Button onPress={context.sayHello}
                title={context.someValue} />
    );
}

const [state, dispatch] = useReducer(reducer, initialState);


function reducer(state, action) {
    switch (action.type) {
        case 'increment':
            return {count: state.count + 1};
        case 'decrement':
            return {count: state.count - 1};
        default:
            throw new Error();
    }
}


function Counter() {
    const [state, dispatch] = React.useReducer(reducer, {count: 0});
    return (
        <View>
            <Text>Count: {state.count}</Text>
            <Button onPress={() => dispatch({type: 'decrement'})}>-</Button>
            <Button onPress={() => dispatch({type: 'increment'})}>+</Button>
        </View>
    );
}




const [state, dispatch] = useReducer(reducer, initialState);

const memoizedValue = useMemo(() => computeExpensiveValue(a, b), [a, b]);




class MyComponent extends React.Component {
    constructor(props) {
        super(props);
        this.myRef = React.createRef();
    }
    render() {
        return <View ref={this.myRef} />;
    }
}



export default class App extends React.Component {

    render() {
        return (
            <MyComponent/>
        );
    }
}


class MyComponent extends React.Component {
    constructor(props) {
        super(props);
        this.myRef = React.createRef();
    }

    render() {
        return (
            <View>
                <Button title="Clear Input"
                        onPress={() => this.myRef.current.clear()}/>
                <TextInput ref={this.myRef}/>
            </View>
        );
    }
}

function MyComponent() {
    const myRef = React.useRef();

    return (
        <View>
            <Button title="Focus Input"
                    onPress={() => myRef.current.focus()} />
            <TextInput ref={myRef}/>
        </View>
    );
}


function MyTabs() {
    return (
        <Tab.Navigator>
            <Tab.Screen name="Home" component={HomeScreen} />
            <Tab.Screen name="Settings" component={SettingsScreen} />
        </Tab.Navigator>
    );
}