import AlephCatalogScreen from "screens/AlephCatalogScreen";
import {BookDetailScreen} from "screens/BookDetailScreen";
import {BookItemScreen} from "screens/BookItemsScreen";
import React from "react";
import {createStackNavigator} from "@react-navigation/stack";
import {CatalogScreens} from "navigation/enums/CatalogScreens";
import {StyleConstants} from "../style/StyleConstants";

const Stack = createStackNavigator();




export const CatalogStack = () => {
    return (
        <Stack.Navigator screenOptions={{headerShown: false}}>
            <Stack.Screen name={CatalogScreens.CATALOG} component={AlephCatalogScreen} />
            <Stack.Screen name={CatalogScreens.DETAIL} component={BookDetailScreen}
                                 options={{  headerShown: true, title: 'Detail Knihy',headerTintColor: StyleConstants.PRIMARY_BLUE_COLOR, headerTitleStyle: {
                                         fontWeight: 'bold',
                                     },}}
            />
            <Stack.Screen name={CatalogScreens.BOOK_ITEMS} component={BookItemScreen}
                                 options={{  headerShown: true, title: 'Exempláře', headerTintColor: StyleConstants.PRIMARY_BLUE_COLOR, headerTitleStyle: {
                                         fontWeight: 'bold',
                                     },}}
            />


        </Stack.Navigator>
    );
};