import {BookDetailScreen} from "screens/BookDetailScreen";
import React from "react";
import {createStackNavigator} from "@react-navigation/stack";
import {HomeScreen} from "../screens/HomeScreen";
import {HomeScreens} from "navigation/enums/HomeScreens";
import {ReservationsScreen} from "../screens/ReservationsScreen";
import {LoansScreen} from "../screens/LoansScreen";
import {StyleConstants} from "../style/StyleConstants";
import {HistoryScreen} from "../screens/HistoryScreen";

const Stack = createStackNavigator();


export const HomeStack = () => {
    return (
        <Stack.Navigator screenOptions={{headerShown: false}}>
            <Stack.Screen name={HomeScreens.HOME} component={HomeScreen}/>
            <Stack.Screen name={HomeScreens.RESERVATIONS} component={ReservationsScreen}
                          options={{headerShown: true, title: 'Rezervace', headerTintColor: StyleConstants.PRIMARY_BLUE_COLOR, headerTitleStyle: {
                                  fontWeight: 'bold',
                              },}}
            />
            <Stack.Screen name={HomeScreens.LOANS} component={LoansScreen}
                          options={{headerShown: true, title: 'Výpůjčky', headerTintColor: StyleConstants.PRIMARY_BLUE_COLOR, headerTitleStyle: {
                                  fontWeight: 'bold',
                              },}}
            />
            <Stack.Screen name={HomeScreens.HISTORY} component={HistoryScreen}
                          options={{headerShown: true, title: 'Historie výpůjček', headerTintColor: StyleConstants.PRIMARY_BLUE_COLOR, headerTitleStyle: {
                                  fontWeight: 'bold',
                              },}}
            />
            <Stack.Screen name={HomeScreens.BOOK_DETAIL} component={BookDetailScreen}
                          options={{headerShown: true, title: 'Detail knihy', headerTintColor: StyleConstants.PRIMARY_BLUE_COLOR, headerTitleStyle: {
                                  fontWeight: 'bold',
                              },}}
            />


        </Stack.Navigator>
    );
};